# This file is part of FatxFast.
#
#    FatxFast is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    FatxFast is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with FatxFast.  If not, see <http://www.gnu.org/licenses/>.

# Versioning based on: 
# http://en.wikipedia.org/wiki/Versioning#Designating_development_stage
__author__ = "dryatu (c) 2013"
__version__ = "1.1.2"
from pygame import USEREVENT

GAMEEVENT = 6415
INPUTEVENT = 14985
GUIEVENT = 13337
PLAYEREVENT = 16666

class Event(object):

    def __init__(self, eventname,**kwargs):
        self.action = eventname
        for setting, value in kwargs.items():
            setattr(self, setting, value)
        ##Pygame uses 24 for USEREVENTs
        ##Removes possible conflicts with type checks
        self.type = USEREVENT

class GameEvent(Event):
    """GAME EVENTS"""
    def __init__(self, eventname, **kwargs):
        super(GameEvent, self).__init__(eventname,**kwargs)
        self.type = GAMEEVENT

class GuiEvent(Event):

    def __init__(self, eventname,**kwargs):
        super(GuiEvent, self).__init__(eventname,**kwargs)
        self.type = GUIEVENT


class PlayerEvent(Event): 
    """Player Events"""
    def __init__(self, eventname,**kwargs):
        super(GuiEvent, self).__init__(eventname,**kwargs)
        self.type = PLAYEREVENT

