from FatxFast.gui.hud.frame import Frame
import time

class AttributesFrame(Frame):
    # Part of GameFrame
    def __init__(self, game, player, **kwargs):
        super(AttributesFrame, self).__init__(game, **kwargs)  
        self._player = player
        self._cache_points = self._player.points
        self._cache_maps = self._player.maps_left
        self.create_text(
            {"name": "points-icon",
                "x": 65,
                "y": 56,
                "size": 26,
                "container": self,
                "text": u"\ue800",
                "font": "fontello.ttf"})
        self._points_widget = self.create_text(
            {"name": "points",
                "x": 100,
                "font":"lavoir.ttf",
                "y": 60,
                "container": self,
                "text": "POINTS: {0}".format(self._player.points)})
        self.create_text(
            {"name": "maps-left-icon",
                "color": "gold3",
                "x": 65,
                "y": 90,
                "size": 26,
                "container": self,
                "text": u"\ue801",
                "font": "fontello.ttf"})
        self._maps_left_widget = self.create_text(
            {"name": "maps-left"+str(id(player)),
                "color": "gold3",
                "font":"lavoir.ttf",
                "x": 100,
                "y": 90,
                "container": self,
                "text": "{0}".format(self._player.maps_left)})

    def update(self, dt):
        if self._cache_points != self._player.points:
            self._cache_points = self._player.points
            self._points_widget.text = "POINTS: {0}".format(self._cache_points)
        if self._cache_maps != self._player.maps_left:
            self._cache_maps = self._player.maps_left
            self._maps_left_widget.text = "{0}".format(self._cache_maps)
