# This file is part of FatxFast.
#
#    FatxFast is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    FatxFast is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with FatxFast.  If not, see <http://www.gnu.org/licenses/>.

# Versioning based on: 
# http://en.wikipedia.org/wiki/Versioning#Designating_development_stage
__author__ = "dryatu (c) 2013"
__version__ = "1.1.2"


from FatxFast.modes import scoredmode
from FatxFast.constants import *

class TimedMode(scoredmode.ScoredMode):    
   
    def __init__(self, scene, **kwargs):
        super(TimedMode, self).__init__(scene, **kwargs)
    
    def level_up(self, player):
        self.scene.levelsystem.increase_level()
        super(TimedMode, self).level_up(player)

    def load_level_assets(self):
        super(TimedMode, self).load_level_assets()
        if "map_time" in self.scene.levelsystem.level_complexity["data"]:
            self.scene.time += \
                self.scene.levelsystem.level_complexity["data"]["map_time"]

    def update(self, dt):
        super(TimedMode, self).update(dt)
        self.scene.time -= dt
        if self.scene.time <= 0:
            self.end(self.player1)
